//+------------------------------------------------------------------+
//|                                            SAR.mq5 |
//|                        Copyright 2020, Abrazotech Software Corp. |
//|                                       https://www.abrazotech.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, Abrazo Software Corp."
#property link      "https://www.abrazotech.com"
#property version   "2.019"
#property description "目標 : small 減少平均 lost "

/*例外處理 
 預設動作 
   1. Init   : 啟動時未平倉deal 新增到 control group(預設長周期)

   
Log 
V1.885 : Change group, Panel init group add init as small
===============  :  修正 :  =================

*/
//+------------------------------------------------------------------+
//| Include                                                          |
//+------------------------------------------------------------------+
#include "KExpert2.mqh"
#include "SgSAR_TF.mqh"         //--- available signals
#include "Money_SAR.mqh"          //--- available money management

//#include "panel_properties.mqh"  // 指標狀態
//#include "Panel_Sergey/Panel_Sergey.mqh"          // 手動下單面板  CPannel.mqh
//#include "Log_History_Deals.mqh"

//+------------------------------------------------------------------+
//| Inputs                                                           |
//+------------------------------------------------------------------+
//--- inputs for expert

ulong                    Expert_MagicNumber     = 28759;      //
bool                     Expert_EveryTick       = false;      //

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
input string             Expert_Title           = "Dual TF MACD (1HR ,10mins)";    // Muti Time Frame -tailing (SAR)  Ver: 2.019
input ENUM_TIMEFRAMES    Op_Period_Big          = PERIOD_H1; // Big - Operation Period   From 1HR   ~ 1Day
input ENUM_TIMEFRAMES    Op_Period_Small        = PERIOD_M10;// Small Operation Period   From 2mins ~ 30mins
input uint               TimeOut_Min_Small      =  90;       // Small Time out function close,60
input uint               TimeOut_Min_Big        = 200;       // Big   Time out function close,180
input bool               MA_Samll_infilter      = 1;       // Small open filter by ma


input group  "Policy Time Frame Policy:: 3 兩組都開獨立 4 Small for prdict"
input uint               Op_Period_Policy       = 0x3;    // 1 Big, 2 Small, 3Big Size Zero 4.Small zero  5 Daul ,6 Default TEST_MODE
input uint               Op_RISK_SL_Policy      = 0x3;    // 0 fix, 1 ATR, 2 SAR  3 SAR+ATR 4 SAR+MaxSL
input double             Money_Risk_Percent     = 0.003;  // Money Risk percentage     (ATR)
input double             Money_FixLots_Big      = 0.0;    // (Big___Period) Money Fix Volumes
input double             Money_FixLots_Small    = 0.0;    // (Small Period) Money Fix Volumes
//預測模式: 小週期的Lots由大週期定義外,其餘照正常小周期的真實SL,tailing 都是小週期
input group  "Signal Daul MACD"
input ENUM_APPLIED_PRICE Signal_MACD_Applied    = PRICE_CLOSE;// MACD Prices series
input int                Small_EMA_filter       = 35;   // EMA filter of Small MACD 
input group  "RISK Control --Money Size & Trailing";//--- inputs for trailing /money
input bool               Tailing_On                = 1;      // (Test Flag) Tailing function On
input double             Trailing_SarStep_Big         = 0.02;   // Trailing Speed  (Big   SAR)
input double             Trailing_SarStep_Small       = 0.0117; // Trailing Speed  (Small SAR)
input double             Trailing_ParabolicSAR_Maximum= 0.2;    // Trailing Maximum rate     (SAR)
input int                Trailing_DefGroup            = 1;      // Create Deal Initial Op Group: 1Big 0 Small(SAR)
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
input double             Big_ATR_SL_Factor      = 3.5;   // (Big__Period) ATR_SL  - max drop down
input double             Big_SL_MinPiP_Risk     = 396;   // (Big__Period) Init Min SL 15 start mins
input double             Big_SL_MaxPiP_Risk     = 2000;  // (Big__Period) Init Max SL 2000 start mins
input double             Big_TK_Risk            = 11890 ;// (Big__Period) Take Profit level (in points)
input double             Big_ATR_TP_Factor      = 20 ;   // (Big__Period) ATR_TP  - max profit
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
input double            Small_ATR_SL_Factor     = 1.45;      // (Small Period) ATR_SL  - max drop down
input double            Small_SL_MinPiP_Risk    = 49;       // (Small Period) Init Min SL 15 start mins
input double            Small_SL_MaxPiP_Risk    = 120;       // (Small Period) Init Max SL 100
input double            Small_TK_Risk           = 800.0;    // (Small Period) Take Profit level (in points)
input double            Small_ATR_TP_Factor     = 10;      // (Small Period) ATR_TP  - max profit
input int               Small_SL_LevelPiP       = 50;       // (Small Timeout delta SL level)

input group  "Signal filter notused"
input int                Signal_Expiration      = 4;   // Expiration of pending orders (in bars)
input double             Signal_PriceLevel      = 0.0;  // Price level to execute a deal
extern int Slippage     = 15;

extern ENUM_TIMEFRAMES    Op_Big_Period         = Op_Period_Big; // - Big - Operation Period
extern ENUM_TIMEFRAMES    Op_Small_Period       = Op_Period_Small;// Small Operation Period
extern double             panel_Big___TP   = Big_TK_Risk;// (Big___Period)      Take Profit level (in points)
extern double             panel_Small_TP   = Small_TK_Risk;// (Big___Period)    Take Profit level (in points)
//+------------------------------------------------------------------+
//| Global expert object                                             |
//+------------------------------------------------------------------+

CKExpert ExtExpert;
CPositionInfo     k_position;       // position info object
//CMasterWindows    m_pannel;         // 手動下單 CKPanel CMasterWindows

//CKEAInfo mkinfo;                  // 手動下單
MqlTradeResult    m_result_panel;   // 手動下單
static datetime   time_tag_start;
extern datetime history_start;
//+------------------------------------------------------------------+
//| Initialization function of the expert                            |
//+------------------------------------------------------------------+
int OnInit()
  {
   /*  if(Symbol()!="EURUSD"){
        printf(__FUNCTION__+": Not Support Product"); //KK Check Support !!!!!!~~~~~~~~~~~~~~
        return(INIT_FAILED);
     }*/
//--- Initializing expert

   if(!ExtExpert.Init(Symbol(),Period(),Expert_EveryTick,Expert_MagicNumber))
     {
      //--- failed
      printf(__FUNCTION__+": error initializing expert");
      ExtExpert.Deinit();
      return(INIT_FAILED);
     }

   long gatesecond;
   if(Op_Period_Policy ==2) 
       gatesecond = PeriodSeconds(Op_Period_Small);
   else
       gatesecond = PeriodSeconds(Op_Period_Big);     
   if( gatesecond  < PeriodSeconds() )
    {
      printf("Error Input/Setting:: Running Timeframe > small/Big TF");
      return(INIT_FAILED);
    }
    if(Trailing_ParabolicSAR_Maximum==0||Trailing_SarStep_Big==0){
       printf("Error Input Tailing");
       return(INIT_FAILED);
    }
      
//--- Creating signal
   ExtExpert.SetPeriod(Op_Period_Big,Op_Period_Small);
   ExtExpert.SET_TEST_MODE(Op_Period_Policy);
   ExtExpert.SetTimeOut (TimeOut_Min_Small);
   ExtExpert.SetTimeOutBig(TimeOut_Min_Big);
   ExtExpert.SetDefaultTF(Trailing_DefGroup);
   
   CExpertSignal *signal=new CExpertSignal;


   if(signal==NULL)
     {
      //--- failed
      printf(__FUNCTION__+": error creating signal");
      ExtExpert.Deinit();
      return(INIT_FAILED);
     }
//---
   ExtExpert.InitSignal(signal);
  // signal.StopLevel(Signal_StopLevel);
   signal.TakeLevel(Big_TK_Risk);
   signal.Expiration(Signal_Expiration);
//--- Creating filter CSignalMACD
   CSignalSAR *filter0=new CSignalSAR;
   CSignalSAR *filter1=new CSignalSAR;
   ExtExpert.Initfilter(filter0,filter1);//filter0
   if(filter0==NULL||filter1==NULL)
     {
      //--- failed
      printf(__FUNCTION__+": error creating filter0");
      ExtExpert.Deinit();
      return(INIT_FAILED);
     }
   if(Op_Period_Policy==1||Op_Period_Policy==3)
     {
      signal.AddFilter(filter0);
      //--- Set filter parameters
      filter0.PeriodOperation(Op_Period_Big);
   //   filter0.TakeLevel(Big_TK_Risk);
      filter0.Applied(Signal_MACD_Applied);
     }
   if(Op_Period_Policy==2||Op_Period_Policy==3)
     {
      signal.AddFilter(filter1);
      filter1.PeriodOperation(Op_Period_Small);
    //  filter1.StepSmall(Trailing_SarStep_Small);    
   //   filter1.TakeLevel(Small_TK_Risk);       ////必要!!
      filter1.Applied(Signal_MACD_Applied);
      filter1.FilterEMA(Small_EMA_filter);
     }


//--- Set trailing parameters
//--- Creation of money object
   CMoneyATRFixedRisk *money0=new CMoneyATRFixedRisk;
   if(money0==NULL)
     {
      //--- failed
      printf(__FUNCTION__+": error creating money");
      ExtExpert.Deinit();
      return(INIT_FAILED);
     }
//--- Add money to expert (will be deleted automatically))
   if(!ExtExpert.InitMoney(money0))
     {
      //--- failed
      printf(__FUNCTION__+": error initializing money");
      ExtExpert.Deinit();
      return(INIT_FAILED);
     }
//--- Set money parameters
   money0.Set_Policy    (Op_Period_Policy);
   money0.Set_SL_Policy (Op_RISK_SL_Policy);
   
   money0.Percent          (Money_Risk_Percent);
   money0.Set_FixLotsBig   (Money_FixLots_Big);
   money0.Set_FixLotsSmall (Money_FixLots_Small);
   
   money0.SetPeriod_Big(Op_Period_Big);
   money0.SetPeriod_Small(Op_Period_Small);
   
   
  // if(!ExtExpert.InitTrailing(trailing0)||!ExtExpert.InitTrailing(trailing1))
   ExtExpert.Tailingflag (Tailing_On);
   money0.StepBig (Trailing_SarStep_Big);  
   money0.StepSmall(Trailing_SarStep_Small);          
   money0.Maximum(Trailing_ParabolicSAR_Maximum);  
   money0.Set_ATR_SL_InitFactor_Big    (Big_ATR_SL_Factor);   //Big_SL_Factor_Risk
   money0.Set_ATR_SL_InitFactor_Small  (Small_ATR_SL_Factor); //Small_SL_Factor_Risk
   money0.Set_TP_Factor_Big    (Big_ATR_TP_Factor);   //Big_SL_Factor_Risk
   money0.Set_TP_Factor_Small  (Small_ATR_TP_Factor); //Small_SL_Factor_Risk
   money0.Set_TP(Big_TK_Risk,Small_TK_Risk);
   money0.Set_MinSL_Big(Big_SL_MinPiP_Risk);
   money0.Set_MaxSL_Big(Big_SL_MaxPiP_Risk);
   money0.Set_MinSL_Small(Small_SL_MinPiP_Risk);
   money0.Set_MaxSL_Small(Small_SL_MaxPiP_Risk);
   money0.Set_StopLevel_Samll(Small_SL_LevelPiP);
   money0.Set_Filter_Small_MA(MA_Samll_infilter);
    if(Trailing_DefGroup==1){ 
      KInit_Group(Op_Big_Period); //int buy_sell_both=2
    }else{  
      KInit_Group(Op_Small_Period);
    }
    money0.InitSL();
//--- Check all trading objects parameters
   if(!ExtExpert.ValidationSettings())
     {
      //--- failed
      ExtExpert.Deinit();
      return(INIT_FAILED);
     }
   /*
   datetime yesterdayBeg = iTime(NULL, PERIOD_M5, 1),   // Last trading day
       yesterdayEnd = iTime(NULL, PERIOD_M5, 0)-1; // Or Time[0] - Time[0] % 86400 - 1
   int iYestBeg = iBarShift(NULL,0, yesterdayBeg),
   iYestEnd = iBarShift(NULL,0, yesterdayEnd);
   //  nBarsYest= iYestBeg - iYestEnd + 1,
   //bool HighBeforeLow = iYestHi > iYestLo;
   */
//--- Tuning of all necessary indicators
   if(!ExtExpert.InitIndicators())
     {
      //--- failed
      printf(__FUNCTION__+": error initializing indicators");
      ExtExpert.Deinit();
      return(INIT_FAILED);
     }
//   if(!m_pannel.OnInit(ExtExpert.panel_symbol,Expert_MagicNumber,m_result_panel,200,30,ExtExpert.m_money))
//      return(INIT_FAILED);
//--- ok
   //GetPositionProperties();         //左上角Info Panel ( Get the properties and set the panel)
   time_tag_start=TimeCurrent();
   history_start =TimeCurrent(); 
   EventSetTimer(55);      //--- create a timer with a 1 second period
   //const bool Init = EventSetMillisecondTimer(Timer);
   Print("=========================================Version 2.19- B.0.01============================================"); //version); <<https://www.mql5.com/en/forum/314684
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Deinitialization function of the expert                          |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   /*datetime time_tag_end=TimeCurrent();
   string filename = TimeToString(time_tag_start,TIME_DATE)+"_To_"+TimeToString(time_tag_end,TIME_DATE)+".csv";
   if((MQL5InfoInteger(MQL5_TESTER))  && !(MQL5InfoInteger(MQL5_OPTIMIZATION)))   //isTeester &&  && !IsVisualMode()
     {
      ExportHistoryDeals(time_tag_start,time_tag_end,filename); //Trade result save to csv file
     }*/
   ea_order__group.Clear();
   ea_order_policy.Clear();
   ea_deal_order.Clear();
//remove indector
//--- Print the deinitialization reason to the journal
   ExtExpert.Deinit();
   EventKillTimer();
 //  Print(GetDeinitReasonText(reason));
   ObjectsDeleteAll(0);//  Chart identifier. 0 ,long  chart_id int   sub_window=-1, int   type=-1 object type

//--- When deleting from the chart
   //if(reason==REASON_REMOVE)   //--- Delete all objects relating to the info panel from the chart
   //   DeleteInfoPanel();
  }
//+------------------------------------------------------------------+
//| "Tick" event handler function                                    |
//+------------------------------------------------------------------+
void OnTick()
  {
   ExtExpert.OnTick();
   //m_pannel.OnTick();
   //GetPositionProperties();      //--- 左上角Info Panel (Get the properties and update the values on the pannel)
  }
//+------------------------------------------------------------------+
//| "Trade" event handler function                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
   ExtExpert.OnTrade();
  }
//+------------------------------------------------------------------+
//| "Timer" event handler function                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
   int total=PositionsTotal();
   if(total>0 )//&& Op_Period_Policy > 2)
      ExtExpert.OnTimer();   
   /*   
   if(!(MQL5InfoInteger(MQL5_OPTIMIZATION))){
    static uint csv_count = 0;   
    if( csv_count > 1440*30 ){//預設一天記錄一次 1min 60*60*24=86400 
      csv_count = 0;
      datetime time_tag_end = TimeCurrent();
      string filename = TimeToString(time_tag_start,TIME_DATE)+"_To_"+TimeToString(time_tag_end,TIME_DATE)+".csv";
      if (time_tag_end!=time_tag_start){
         if( ExportHistoryDeals(time_tag_start,time_tag_end,filename) ){ //Trade result save to csv file
            Print("Save data to CSV file ",TimeToString(time_tag_end,TIME_DATE));
            time_tag_start = time_tag_end;
         }
     }}else
      csv_count ++;
    }*/        
  }
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,  const double &dparam,const string &sparam)
  {
   //m_pannel.OnEvent(id, lparam, dparam, sparam);
  }
//+------------------------------------------------------------------+
